declare const NNIMIPCLISTENR: string;
/**
 * @brief 错误码
 */
declare enum NNIMErrCode {
    ERR_SUCC = 20001,
    ERR_FAIL = 20002
}
declare enum ImDeviceType {
    IPAD = 0,
    IOS = 1,
    ANDROIDDD = 2,
    PC = 3,
    WEB = 4
}
/**
 * @brief 调用接口的返回值
 */
declare enum NNIMResult {
    NNIM_SUCC = 0,
    NNIM_ERR_PARAM_COUNT_MATCH = 1,
    NNIM_ERR_PARAM_TYPE_MATCH = 2,
    NNIM_ERR_CHATTYPE_INVALID = 3
}
/**
 * @brief 聊天类型
 */
declare enum NNIMChatType {
    CHAT = 2,
    GROUP_CHAT = 3,
    ROOM = 5,
    PARTY_ROOM = 6
}
/**
 * @brief 请求类型
 */
declare enum NNIMPacketType {
    LOGIN = 0,
    LOGOUT = 1,
    CHAT = 2,
    GROUP_CHAT = 3,
    PUSH = 4,
    ROOM = 5,
    PARTY_ROOM = 6,
    MSG = 7,
    SUBSCRIBER = 8,
    API = 9,
    SYSTEM = 10,
    CLOSE = 11,
    LIMIT_QPS_CLOSE = 12,
    APP_STATICS = 13,
    KEEPALIVE = -99,
    LSB = 14
}
/**
 * @brief 命令类型
 */
declare enum NNIMCmdType {
    SEND_MSG = 0,
    NOTIFY = 1,
    JOIN_GROUP = 2,
    DISBAND = 3,
    CREATE = 4,
    REMOVE_MEMBERS = 5,
    JOIN_ROOM = 6,
    CLOSE_ROOM = 7,
    CREATE_ROOM = 9,
    REMOVE_ROOM_MEMBERS = 10,
    ADD_SILENCE = 11,
    REMOVE_SILENCE = 12,
    JOIN_PARTY_ROOM = 13,
    CLOSE_PARTY_ROOM = 14,
    CREATE_PARTY_ROOM = 15,
    REMOVE_PARTY_ROOM_MEMBERS = 16,
    ADD_PARTY_ROOM_SILENCE = 17,
    REMOVE_PARTY_ROOM_SILENCE = 18,
    ACK = 19,
    DELETE_MSG = 20,
    WITHDRAW_MSG = 21,
    CHAT_MSG_SAVE = 22,
    GROUP_CHAT_MSG_SAVE = 23,
    ROOM_MSG_SAVE = 24,
    PARTY_ROOM_MSG_SAVE = 25,
    PUSH_SYS_MSG = 26,
    NOTIFY_MESSAGE = 28,
    BATCH_NOTIFY_MESSAGE_LIST = 29,
    ADD_SUBSCRIBER = 31,
    REMOVE_SUBSCRIBER = 32,
    CLEAN_SCREEN_MSG = 54
}
/**
 * @brief 命令类型
 */
declare enum NNIMMsgType {
    TEXT = 0,
    IMAGE = 1,
    AUDIO = 2,
    VEDIO = 3
}
/**
 * @brief 通知类型
 */
declare enum NNIMNotifyType {
    JOIN_GROUP = 2,
    DISBAND = 3,
    CREATE = 4,
    REMOVE_MEMBERS = 5,
    JOIN_ROOM = 6,
    CLOSE_ROOM = 7,
    CREATE_ROOM = 9,
    REMOVE_ROOM_MEMBERS = 10,
    ADD_SILENCE = 11,
    REMOVE_SILENCE = 12,
    JOIN_PARTY_ROOM = 13,
    CLOSE_PARTY_ROOM = 14,
    CREATE_PARTY_ROOM = 15,
    REMOVE_PARTY_ROOM_MEMBERS = 16,
    SYS_NOTIFY_CHAT = 35,
    SYS_NOTIFY_GROUP_CHAT = 36,
    SYS_NOTIFY_ROOM_CHAT = 37,
    SYS_NOTIFY_PARTY_ROOM_CHAT = 38
}
/**
 * @brief 回执类型
 */
declare enum NNIMNAckType {
    LOGIN_ACK = 0,
    LOGOUT_ACK = 1,
    SEND_MSG_ACK = 2,
    SUBSCRIBER_ACK = 3,
    READ_MSG_ACK = 4,
    DELETE_MSG_ACK = 5,
    WITHDRAW_MSG_ACK = 6,
    ROOM_CREATE_ACK = 7,
    ROOM_JOIN_ACK = 8,
    ROOM_EXIT_ACK = 9,
    ROOM_CLOSE_ACK = 10,
    SENSITIVE_ACK = 11,
    RECONNECT_ACK = 12,
    PARTY_ROOM_CREATE_ACK = 12,
    PARTY_ROOM_JOIN_ACK = 13,
    PARTY_ROOM_EXIT_ACK = 14,
    PARTY_ROOM_CLOSE_ACK = 15,
    PARTY_SENSITIVE_ACK = 16
}

export { ImDeviceType, NNIMChatType, NNIMCmdType, NNIMErrCode, NNIMIPCLISTENR, NNIMMsgType, NNIMNAckType, NNIMNotifyType, NNIMPacketType, NNIMResult };
